
/* 
 * File:   GSLBlock.h
 * Author: skidmarks
 *
 * Created on December 15, 2017, 2:53 PM
 */

#ifndef GSLBLOCK_H
#define GSLBLOCK_H

# include <gsl/gsl_block.h>

#include <gsl/gsl_block_double.h>

# include "GSLData.h"

using namespace std;

namespace gsl {
   
   class GSLBlock : GSLData {
      private:

      public:
         GSLBlock(size_t size)             : GSLData(size, gslBlock, (void*)gsl_block_alloc(size)) { };
         GSLBlock(size_t size, int calloc) : GSLData(size, gslBlock, (void*)gsl_block_calloc(size)) { };
         virtual ~GSLBlock()              { };
         virtual int fscanf(FILE stream, gsl_block b);
         virtual string toString();

         /******************************************************
          *                Universal  Properties               *
          ******************************************************/

         virtual void*  data()                        { return ((gsl_block*)block())->data; }

      private:
         GSLBlock(const GSLBlock& orig);
   }; // class GSLBlock

} // namespace gls
#endif /* GSLBLOCK_H */

