
/* 
 * File:   gslStruct.h
 * Author: skidmarks
 *
 * Created on December 25, 2017, 10:37 AM
 */

#ifndef GSLSTRUCT_H
#define GSLSTRUCT_H

#ifdef __cplusplus
extern "C" {
#endif


//   
//   /******************************************************
//    *        Common Matrix and Vector properties         *
//    ******************************************************/
//   virtual double max()      = 0;               // maximum value
//   virtual double min()      = 0;               // maximum value
//   
//   virtual int    isneg()    = 0;               // true: is negative
//   virtual int    isnonneg() = 0;               // true: is not negative
//   virtual int    isnull()   = 0;               // true: structure is null
//   virtual int    ispos()    = 0;               // true: is positive
//      
//   /******************************************************
//    *    Accessing & initializing Matrices and Vectors   *
//    ******************************************************/
//   virtual double * const_ptr(size_t row, size_t col = 0) = 0;
//   virtual double get(const size_t row, const size_t col = 0) = 0;
//   virtual double* ptr(size_t row, size_t col = 0) = 0;
//   virtual void   set_all(double x) = 0;
//   virtual void   set_zero() = 0;
//   virtual void   set(const double x, const size_t row, const size_t col = 0) = 0;
//      
//   /******************************************************
//    *            Matrix and Vector Arithmetic            *
//    ******************************************************/
//   virtual int add(GSLData& b) = 0;
//   virtual int add_constant(const double x) = 0;
//   virtual int sub(GSLData& b) = 0;
//   virtual int scale(const double x) = 0;
//      
//   /******************************************************
//    *            Matrix and Vector Operations            *
//    ******************************************************/
//   virtual int    equal(GSLData& b) = 0;
//   virtual void   minmax(double * min, double * max)  = 0;
//   virtual size_t max_index()  = 0;
//   virtual size_t min_index()  = 0;
//   virtual void   minmax_index(size_t * imin, size_t * jmin, size_t * imax = 0, size_t* jmax = 0)  = 0;
//   
//   /******************************************************
//    *            Copying Matrices and Vectors            *
//    ******************************************************/
//   virtual int memcpy(GSLData& dest) = 0;
//   virtual int swap(GSLData& dest) = 0;
//   
//   /******************************************************
//    *                  Vector Arithmetic                 *
//    ******************************************************/
//   virtual int div(GSLData& b) = 0;
//   virtual int mul(GSLData& b) = 0;
//   
//   /******************************************************
//    *                    Common Views                    *
//    ******************************************************/
//   virtual GSLData view_array(double* base, const size_t number, size_t col=0) = 0;
//   virtual const GSLData const_view_array(const double* base, const size_t number, size_t col=0) = 0;
// 
//   /******************************************************
//    *                    Vector Views                    *
//    ******************************************************/
//   virtual GSLData subvector(const size_t offset, const size_t number) = 0;
//   virtual GSLData subvector_with_stride(const size_t offset, const size_t number, const size_t stride) = 0;
//   
//   /******************************************************
//    *                const Vector Views                  *
//    ******************************************************/
//   virtual const GSLData const_subvector(const size_t offset, const size_t number) = 0;
//   virtual const GSLData const_subvector_with_stride(const size_t offset, const size_t number, const size_t stride) = 0;
//   
//   /******************************************************
//    *                    Vector Misc                     *
//    ******************************************************/
//   virtual int swap_elements(size_t row1, size_t row2) = 0;
//   virtual int reverse() = 0;
//      
//   /******************************************************
//    *          Accessing & initializing Matrices         *
//    ******************************************************/
//   virtual void set_identity() = 0;
//  
//   /******************************************************
//    *                    Matrix Views                    *
//    ******************************************************/
//   virtual GSLData   submatrix(size_t row, size_t col, size_t rows, size_t cols) = 0;
//   virtual GSLData   subrow(size_t row, size_t offset, size_t n) = 0;
//   virtual GSLData   view_array_with_tda(double * v, size_t rows, size_t cols, size_t tda) = 0;
//   virtual GSLData   view_vector(GSLData * v, size_t rows, size_t cols) = 0;
//   virtual GSLData   view_vector_with_tda(GSLData * v, size_t rows, size_t cols, size_t tda) = 0;
//  
//   /******************************************************
//    *                 const Matrix Views                 *
//    ******************************************************/
//   virtual const GSLData   const_submatrix(size_t row, size_t col, size_t rows, size_t cols) = 0;
//   virtual const GSLData   const_view_array_with_tda(double * v, size_t rows, size_t cols, size_t tda) = 0;
//   virtual const GSLData   const_view_vector(GSLData * v, size_t rows, size_t cols) = 0;
//   virtual const GSLData   const_view_vector_with_tda(GSLData * v, size_t rows, size_t cols, size_t tda) = 0;
//  
//   /******************************************************
//    *            Row and Column Matrix Views             *
//    ******************************************************/
//   virtual GSLData row(size_t row) = 0;
//   virtual GSLData col(size_t col) = 0;
//   virtual GSLData subrow(size_t row, size_t offset, size_t number) = 0;
//   virtual GSLData subcol(size_t col, size_t offset, size_t number) = 0;
//   virtual GSLData diagonal() = 0;
//   virtual GSLData subdiagonal(size_t diagonal) = 0;
//   virtual GSLData superdiagonal(size_t diagonal) = 0;
//  
//   /******************************************************
//    *        const Row and Column Matrix Views           *
//    ******************************************************/
//   virtual const GSLData const_row(size_t row) = 0;
//   virtual const GSLData const_col(size_t col) = 0;
//   virtual const GSLData const_subrow(size_t row, size_t offset, size_t number) = 0;
//   virtual const GSLData const_subcol(size_t col, size_t offset, size_t number) = 0;
//   virtual const GSLData const_diagonal() = 0;
//   virtual const GSLData const_subdiagonal(size_t diagonal) = 0;
//   virtual const GSLData const_superdiagonal(size_t diagonal) = 0;
//   
//   /******************************************************
//    *          Matrix Copying Rows and Columns           *
//    ******************************************************/
//   virtual int get_row(GSLData* v, size_t length) = 0;
//   virtual int get_col(GSLData* v, size_t length) = 0;
//   virtual int set_row(GSLData* v, size_t row)    = 0;
//   virtual int set_col(GSLData* v, size_t col)    = 0;
//   
//   
//   /******************************************************
//    *        Matrix Exchanging Rows and Columns          *
//    ******************************************************/
//   virtual int swap_rows(size_t row1, size_t row2) = 0;
//   virtual int swap_cols(size_t col1, size_t col2) = 0;
//   virtual int swap_rowcol(size_t row, size_t col) = 0;
//   virtual int transpose_memcpy(GSLData* dest) = 0;
//   virtual int transpose() = 0;
//   
//   /******************************************************
//    *                  Matrix Operations                 *
//    ******************************************************/
//   virtual int mul_elements(GSLData* b) = 0;
//   virtual int div_elements(GSLData* b) = 0;
      


#ifdef __cplusplus
}
#endif

#endif /* GSLSTRUCT_H */

